#!/usr/bin/env guile -s
!#
;; extract.scm
;;
;; usage:
;;  guile extract.scm /path/to/ecmascript/parser.scm > orig-parser.scm
;;
;; Copyright (C) 2015 Matthew R. Wette
;;
;; This software is covered by the GNU LESSER PUBLIC GENERAL LICENCE 
;; See COPYING.LESSER included with this distribution.


(use-modules (ice-9 rdelim))

(let* ((files (program-arguments)))
  (if (= 2 (length files))
      (with-input-from-file (cadr files)
	(lambda ()
	  (simple-format #t "(define raw-spec\n")
	  (let iter ((line (read-line)))
	    (if (string-contains line "(lalr-parser")
		(display line)
		(iter (read-line))))
	  (newline)
	  (let iter ((line (read-line)))
	    (unless (eof-object? line)
	      (display line) (newline)
	      (iter (read-line))))))))

;;; --- last line
