(define raw-spec
  (lalr-spec
    (start Program)
    (grammar
      ((Program
         (SourceElements ($$ $1))
         ('$end ($$ *eof-object*)))
       (SourceElement
         (Statement ($$ $1))
         (FunctionDeclaration ($$ $1)))
       (FunctionDeclaration
         ("function"
          '$ident
          "("
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(var (,$2 (lambda () ,$6)))))
         ("function"
          '$ident
          "("
          FormalParameterList
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(var (,$2 (lambda ,$4 ,$7))))))
       (FunctionExpression
         ("function"
          "("
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(lambda () ,$5)))
         ("function"
          '$ident
          "("
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(lambda () ,$6)))
         ("function"
          "("
          FormalParameterList
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(lambda ,$3 ,$6)))
         ("function"
          '$ident
          "("
          FormalParameterList
          ")"
          "{"
          FunctionBody
          "}"
          ($$ `(lambda ,$4 ,$7))))
       (FormalParameterList
         ('$ident ($$ `(,$1)))
         (FormalParameterList
           ","
           '$ident
           ($$ `(,@$1 ,$3))))
       (SourceElements
         (SourceElement ($$ $1))
         (SourceElements
           SourceElement
           ($$ (if (and (pair? $1) (eq? (car $1) 'begin))
                 `(begin ,@(cdr $1) ,$2)
                 `(begin ,$1 ,$2)))))
       (FunctionBody
         (SourceElements ($$ $1))
         (($$ '(begin))))
       (Statement
         (Block ($$ $1))
         (VariableStatement ($$ $1))
         (EmptyStatement ($$ $1))
         (ExpressionStatement ($$ $1))
         (IfStatement ($$ $1))
         (IterationStatement ($$ $1))
         (ContinueStatement ($$ $1))
         (BreakStatement ($$ $1))
         (ReturnStatement ($$ $1))
         (WithStatement ($$ $1))
         (LabelledStatement ($$ $1))
         (SwitchStatement ($$ $1))
         (ThrowStatement ($$ $1))
         (TryStatement ($$ $1)))
       (Block ("{" StatementList "}" ($$ `(block ,$2))))
       (StatementList
         (Statement ($$ $1))
         (StatementList
           Statement
           ($$ (if (and (pair? $1) (eq? (car $1) 'begin))
                 `(begin ,@(cdr $1) ,$2)
                 `(begin ,$1 ,$2)))))
       (VariableStatement
         ("var" VariableDeclarationList ($$ `(var ,@$2))))
       (VariableDeclarationList
         (VariableDeclaration ($$ `(,$1)))
         (VariableDeclarationList
           ","
           VariableDeclaration
           ($$ `(,@$1 ,$2))))
       (VariableDeclarationListNoIn
         (VariableDeclarationNoIn ($$ `(,$1)))
         (VariableDeclarationListNoIn
           ","
           VariableDeclarationNoIn
           ($$ `(,@$1 ,$2))))
       (VariableDeclaration
         ('$ident ($$ `(,$1)))
         ('$ident Initialiser ($$ `(,$1 ,$2))))
       (VariableDeclarationNoIn
         ('$ident ($$ `(,$1)))
         ('$ident Initialiser ($$ `(,$1 ,$2))))
       (Initialiser ("=" AssignmentExpression ($$ $2)))
       (InitialiserNoIn
         ("=" AssignmentExpressionNoIn ($$ $2)))
       (EmptyStatement (";" ($$ '(begin))))
       (ExpressionStatement (Expression ";" ($$ $1)))
       (IfStatement
         ("if"
          "("
          Expression
          ")"
          Statement
          "else"
          Statement
          ($$ `(if ,$3 ,$5 ,$7)))
         ("if"
          "("
          Expression
          ")"
          Statement
          ($$ `(if ,$3 ,$5))))
       (IterationStatement
         ("do"
          Statement
          "while"
          "("
          Expression
          ")"
          ";"
          ($$ `(do ,$2 ,$5)))
         ("while"
          "("
          Expression
          ")"
          Statement
          ($$ `(while ,$3 ,$5)))
         ("for"
          "("
          ";"
          ";"
          ")"
          Statement
          ($$ `(for #f #f #f ,$6)))
         ("for"
          "("
          ";"
          ";"
          Expression
          ")"
          Statement
          ($$ `(for #f #f ,$5 ,$7)))
         ("for"
          "("
          ";"
          Expression
          ";"
          ")"
          Statement
          ($$ `(for #f ,$4 #f ,$7)))
         ("for"
          "("
          ";"
          Expression
          ";"
          Expression
          ")"
          Statement
          ($$ `(for #f ,$4 ,$6 ,$8)))
         ("for"
          "("
          ExpressionNoIn
          ";"
          ";"
          ")"
          Statement
          ($$ `(for ,$3 #f #f ,$7)))
         ("for"
          "("
          ExpressionNoIn
          ";"
          ";"
          Expression
          ")"
          Statement
          ($$ `(for ,$3 #f ,$6 ,$8)))
         ("for"
          "("
          ExpressionNoIn
          ";"
          Expression
          ";"
          ")"
          Statement
          ($$ `(for ,$3 ,$5 #f ,$8)))
         ("for"
          "("
          ExpressionNoIn
          ";"
          Expression
          ";"
          Expression
          ")"
          Statement
          ($$ `(for ,$3 ,$5 ,$7 ,$9)))
         ("for"
          "("
          "var"
          VariableDeclarationListNoIn
          ";"
          ";"
          ")"
          Statement
          ($$ `(for (var ,@$4) #f #f ,$8)))
         ("for"
          "("
          "var"
          VariableDeclarationListNoIn
          ";"
          ";"
          Expression
          ")"
          Statement
          ($$ `(for (var ,@$4) #f ,$7 ,$9)))
         ("for"
          "("
          "var"
          VariableDeclarationListNoIn
          ";"
          Expression
          ";"
          ")"
          Statement
          ($$ `(for (var ,@$4) ,$6 #f ,$9)))
         ("for"
          "("
          "var"
          VariableDeclarationListNoIn
          ";"
          Expression
          ";"
          Expression
          ")"
          Statement
          ($$ `(for (var ,@$4) ,$6 ,$8 ,$10)))
         ("for"
          "("
          LeftHandSideExpression
          "in"
          Expression
          ")"
          Statement
          ($$ `(for-in ,$3 ,$5 ,$7)))
         ("for"
          "("
          "var"
          VariableDeclarationNoIn
          "in"
          Expression
          ")"
          Statement
          ($$ `(begin (var ,$4) (for-in (ref ,@$4) ,$6 ,$8)))))
       (ContinueStatement
         ("continue" '$ident ";" ($$ `(continue ,$2)))
         ("continue" ";" ($$ `(continue))))
       (BreakStatement
         ("break" '$ident ";" ($$ `(break ,$2)))
         ("break" ";" ($$ `(break))))
       (ReturnStatement
         ("return" Expression ";" ($$ `(return ,$2)))
         ("return" ";" ($$ `(return))))
       (WithStatement
         ("with"
          "("
          Expression
          ")"
          Statement
          ($$ `(with ,$3 ,$5))))
       (SwitchStatement
         ("switch"
          "("
          Expression
          ")"
          CaseBlock
          ($$ `(switch ,$3 ,@$5))))
       (CaseBlock
         ("{" "}" ($$ '()))
         ("{" CaseClauses "}" ($$ $2))
         ("{"
          CaseClauses
          DefaultClause
          "}"
          ($$ `(,@$2 ,@$3)))
         ("{" DefaultClause "}" ($$ `(,$2)))
         ("{"
          DefaultClause
          CaseClauses
          "}"
          ($$ `(,@$2 ,@$3))))
       (CaseClauses
         (CaseClause ($$ `(,$1)))
         (CaseClauses CaseClause ($$ `(,@$1 ,$2))))
       (CaseClause
         ("case" Expression ":" ($$ `(case ,$2)))
         ("case"
          Expression
          ":"
          StatementList
          ($$ `(case ,$2 ,$4))))
       (DefaultClause
         ("default" ":" ($$ `(default)))
         ("default" ":" StatementList ($$ `(default ,$3))))
       (LabelledStatement
         ('$ident ":" Statement ($$ `(label ,$1 ,$3))))
       (ThrowStatement
         ("throw" Expression ";" ($$ `(throw ,$2))))
       (TryStatement
         ("try" Block Catch ($$ `(try ,$2 ,$3 #f)))
         ("try" Block Finally ($$ `(try ,$2 #f ,$3)))
         ("try"
          Block
          Catch
          Finally
          ($$ `(try ,$2 ,$3 ,$4))))
       (Catch ("catch"
               "("
               '$ident
               ")"
               Block
               ($$ `(catch ,$3 ,$5))))
       (Finally ("finally" Block ($$ `(finally ,$2))))
       (PrimaryExpression
         ("this" ($$ 'this))
         ("null" ($$ 'null))
         ("true" ($$ 'true))
         ("false" ($$ 'false))
         ('$ident ($$ `(ref ,$1)))
         ('$string ($$ `(string ,$1)))
         ('$regexp ($$ `(regexp ,$1)))
         ('$fx ($$ `(number ,$1)))
         ("."
          '$fx
          ($$ `(number
                 ,(string->number
                    (string-append "." (number->string $2))))))
         (ArrayLiteral ($$ $1))
         (ObjectLiteral ($$ $1))
         ("(" Expression ")" ($$ $2)))
       (ArrayLiteral
         ("[" "]" ($$ '(array)))
         ("[" Elision "]" ($$ '(array ,@$2)))
         ("[" ElementList "]" ($$ `(array ,@$2)))
         ("[" ElementList "," "]" ($$ `(array ,@$2)))
         ("["
          ElementList
          ","
          Elision
          "]"
          ($$ `(array ,@$2))))
       (ElementList
         (AssignmentExpression ($$ `(,$1)))
         (Elision AssignmentExpression ($$ `(,@$1 ,$2)))
         (ElementList
           ","
           AssignmentExpression
           ($$ `(,@$1 ,$3)))
         (ElementList
           ","
           Elision
           AssignmentExpression
           ($$ `(,@$1 ,@$3 ,$4))))
       (Elision
         ("," ($$ '((number 0))))
         (Elision "," ($$ `(,@$1 (number 0)))))
       (ObjectLiteral
         ("{" "}" ($$ `(object)))
         ("{"
          PropertyNameAndValueList
          "}"
          ($$ `(object ,@$2))))
       (PropertyNameAndValueList
         (PropertyName
           ":"
           AssignmentExpression
           ($$ `((,$1 ,$3))))
         (PropertyNameAndValueList
           ","
           PropertyName
           ":"
           AssignmentExpression
           ($$ `(,@$1 (,$3 ,$5)))))
       (PropertyName
         ('$ident ($$ $1))
         ('$string ($$ (string->symbol $1)))
         ('$fx ($$ $1)))
       (MemberExpression
         (PrimaryExpression ($$ $1))
         (FunctionExpression ($$ $1))
         (MemberExpression
           "["
           Expression
           "]"
           ($$ `(aref ,$1 ,$3)))
         (MemberExpression
           "."
           '$ident
           ($$ `(pref ,$1 ,$3)))
         ("new"
          MemberExpression
          Arguments
          ($$ `(new ,$2 ,$3))))
       (NewExpression
         (MemberExpression ($$ $1))
         ("new" NewExpression ($$ `(new ,$2 ()))))
       (CallExpression
         (MemberExpression Arguments ($$ `(call ,$1 ,$2)))
         (CallExpression Arguments ($$ `(call ,$1 ,$2)))
         (CallExpression
           "["
           Expression
           "]"
           ($$ `(aref ,$1 ,$3)))
         (CallExpression "." '$ident ($$ `(pref ,$1 ,$3))))
       (Arguments
         ("(" ")" ($$ '()))
         ("(" ArgumentList ")" ($$ $2)))
       (ArgumentList
         (AssignmentExpression ($$ `(,$1)))
         (ArgumentList
           ","
           AssignmentExpression
           ($$ `(,@$1 ,$3))))
       (LeftHandSideExpression
         (NewExpression ($$ $1))
         (CallExpression ($$ $1)))
       (PostfixExpression
         (LeftHandSideExpression ($$ $1))
         (LeftHandSideExpression "++" ($$ `(postinc ,$1)))
         (LeftHandSideExpression "--" ($$ `(postdec ,$1))))
       (UnaryExpression
         (PostfixExpression ($$ $1))
         ("delete" UnaryExpression ($$ `(delete ,$2)))
         ("void" UnaryExpression ($$ `(void ,$2)))
         ("typeof" UnaryExpression ($$ `(typeof ,$2)))
         ("++" UnaryExpression ($$ `(preinc ,$2)))
         ("--" UnaryExpression ($$ `(predec ,$2)))
         ("+" UnaryExpression ($$ `(+ ,$2)))
         ("-" UnaryExpression ($$ `(- ,$2)))
         ("~" UnaryExpression ($$ `(~ ,$2)))
         ("!" UnaryExpression ($$ `(! ,$2))))
       (MultiplicativeExpression
         (UnaryExpression ($$ $1))
         (MultiplicativeExpression
           "*"
           UnaryExpression
           ($$ `(* ,$1 ,$3)))
         (MultiplicativeExpression
           "/"
           UnaryExpression
           ($$ `(/ ,$1 ,$3)))
         (MultiplicativeExpression
           "%"
           UnaryExpression
           ($$ `(% ,$1 ,$3))))
       (AdditiveExpression
         (MultiplicativeExpression ($$ $1))
         (AdditiveExpression
           "+"
           MultiplicativeExpression
           ($$ `(+ ,$1 ,$3)))
         (AdditiveExpression
           "-"
           MultiplicativeExpression
           ($$ `(- ,$1 ,$3))))
       (ShiftExpression
         (AdditiveExpression ($$ $1))
         (ShiftExpression
           "<<"
           MultiplicativeExpression
           ($$ `(<< ,$1 ,$3)))
         (ShiftExpression
           ">>"
           MultiplicativeExpression
           ($$ `(>> ,$1 ,$3)))
         (ShiftExpression
           ">>>"
           MultiplicativeExpression
           ($$ `(>>> ,$1 ,$3))))
       (RelationalExpression
         (ShiftExpression ($$ $1))
         (RelationalExpression
           "<"
           ShiftExpression
           ($$ `(< ,$1 ,$3)))
         (RelationalExpression
           ">"
           ShiftExpression
           ($$ `(> ,$1 ,$3)))
         (RelationalExpression
           "<="
           ShiftExpression
           ($$ `(<= ,$1 ,$3)))
         (RelationalExpression
           ">="
           ShiftExpression
           ($$ `(>= ,$1 ,$3)))
         (RelationalExpression
           "instanceof"
           ShiftExpression
           ($$ `(instanceof ,$1 ,$3)))
         (RelationalExpression
           "in"
           ShiftExpression
           ($$ `(in ,$1 ,$3))))
       (RelationalExpressionNoIn
         (ShiftExpression ($$ $1))
         (RelationalExpressionNoIn
           "<"
           ShiftExpression
           ($$ `(< ,$1 ,$3)))
         (RelationalExpressionNoIn
           ">"
           ShiftExpression
           ($$ `(> ,$1 ,$3)))
         (RelationalExpressionNoIn
           "<="
           ShiftExpression
           ($$ `(<= ,$1 ,$3)))
         (RelationalExpressionNoIn
           ">="
           ShiftExpression
           ($$ `(>= ,$1 ,$3)))
         (RelationalExpressionNoIn
           "instanceof"
           ShiftExpression
           ($$ `(instanceof ,$1 ,$3))))
       (EqualityExpression
         (RelationalExpression ($$ $1))
         (EqualityExpression
           "=="
           RelationalExpression
           ($$ `(== ,$1 ,$3)))
         (EqualityExpression
           "!="
           RelationalExpression
           ($$ `(!= ,$1 ,$3)))
         (EqualityExpression
           "==="
           RelationalExpression
           ($$ `(=== ,$1 ,$3)))
         (EqualityExpression
           "!=="
           RelationalExpression
           ($$ `(!== ,$1 ,$3))))
       (EqualityExpressionNoIn
         (RelationalExpressionNoIn ($$ $1))
         (EqualityExpressionNoIn
           "=="
           RelationalExpressionNoIn
           ($$ `(== ,$1 ,$3)))
         (EqualityExpressionNoIn
           "!="
           RelationalExpressionNoIn
           ($$ `(!= ,$1 ,$3)))
         (EqualityExpressionNoIn
           "==="
           RelationalExpressionNoIn
           ($$ `(=== ,$1 ,$3)))
         (EqualityExpressionNoIn
           "!=="
           RelationalExpressionNoIn
           ($$ `(!== ,$1 ,$3))))
       (BitwiseANDExpression
         (EqualityExpression ($$ $1))
         (BitwiseANDExpression
           "&"
           EqualityExpression
           ($$ `(& ,$1 ,$3))))
       (BitwiseANDExpressionNoIn
         (EqualityExpressionNoIn ($$ $1))
         (BitwiseANDExpressionNoIn
           "&"
           EqualityExpressionNoIn
           ($$ `(& ,$1 ,$3))))
       (BitwiseXORExpression
         (BitwiseANDExpression ($$ $1))
         (BitwiseXORExpression
           "^"
           BitwiseANDExpression
           ($$ `(^ ,$1 ,$3))))
       (BitwiseXORExpressionNoIn
         (BitwiseANDExpressionNoIn ($$ $1))
         (BitwiseXORExpressionNoIn
           "^"
           BitwiseANDExpressionNoIn
           ($$ `(^ ,$1 ,$3))))
       (BitwiseORExpression
         (BitwiseXORExpression ($$ $1))
         (BitwiseORExpression
           "|"
           BitwiseXORExpression
           ($$ `(bor ,$1 ,$3))))
       (BitwiseORExpressionNoIn
         (BitwiseXORExpressionNoIn ($$ $1))
         (BitwiseORExpressionNoIn
           "|"
           BitwiseXORExpressionNoIn
           ($$ `(bor ,$1 ,$3))))
       (LogicalANDExpression
         (BitwiseORExpression ($$ $1))
         (LogicalANDExpression
           "&&"
           BitwiseORExpression
           ($$ `(and ,$1 ,$3))))
       (LogicalANDExpressionNoIn
         (BitwiseORExpressionNoIn ($$ $1))
         (LogicalANDExpressionNoIn
           "&&"
           BitwiseORExpressionNoIn
           ($$ `(and ,$1 ,$3))))
       (LogicalORExpression
         (LogicalANDExpression ($$ $1))
         (LogicalORExpression
           "||"
           LogicalANDExpression
           ($$ `(or ,$1 ,$3))))
       (LogicalORExpressionNoIn
         (LogicalANDExpressionNoIn ($$ $1))
         (LogicalORExpressionNoIn
           "||"
           LogicalANDExpressionNoIn
           ($$ `(or ,$1 ,$3))))
       (ConditionalExpression
         (LogicalORExpression ($$ $1))
         (LogicalORExpression
           "?"
           AssignmentExpression
           ":"
           AssignmentExpression
           ($$ `(if ,$1 ,$3 ,$5))))
       (ConditionalExpressionNoIn
         (LogicalORExpressionNoIn ($$ $1))
         (LogicalORExpressionNoIn
           "?"
           AssignmentExpressionNoIn
           ":"
           AssignmentExpressionNoIn
           ($$ `(if ,$1 ,$3 ,$5))))
       (AssignmentExpression
         (ConditionalExpression ($$ $1))
         (LeftHandSideExpression
           AssignmentOperator
           AssignmentExpression
           ($$ `(,$2 ,$1 ,$3))))
       (AssignmentExpressionNoIn
         (ConditionalExpressionNoIn ($$ $1))
         (LeftHandSideExpression
           AssignmentOperator
           AssignmentExpressionNoIn
           ($$ `(,$2 ,$1 ,$3))))
       (AssignmentOperator
         ("=" ($$ '=))
         ("*=" ($$ '*=))
         ("/=" ($$ '/=))
         ("%=" ($$ '%=))
         ("+=" ($$ '+=))
         ("-=" ($$ '-=))
         ("<<=" ($$ '<<=))
         (">>=" ($$ '>>=))
         (">>>=" ($$ '>>>=))
         ("&=" ($$ '&=))
         ("^=" ($$ '^=))
         ("|=" ($$ 'bor=)))
       (Expression
         (AssignmentExpression ($$ $1))
         (Expression
           ","
           AssignmentExpression
           ($$ `(begin ,$1 ,$3))))
       (ExpressionNoIn
         (AssignmentExpressionNoIn ($$ $1))
         (ExpressionNoIn
           ","
           AssignmentExpressionNoIn
           ($$ `(begin ,$1 ,$3)))))))
)
